// Fig. 2.21: fig02_21.cpp
// Calculating compound interest
#include <iostream.h>
#include <iomanip.h>
#include <math.h>

int main()
{
   double amount,              // amount on deposit
          principal = 1000.0,  // starting principal
          rate = .05;          // interest rate

   cout << "Year" << setw( 21 ) 
        << "Amount on deposit" << endl;

   for ( int year = 1; year <= 10; year++ ) {
      amount = principal * pow( 1.0 + rate, year );
      cout << setw( 4 ) << year
           << setiosflags( ios::fixed | ios::showpoint )
           << setw( 21 ) << setprecision( 2 ) 
           << amount << endl;
   }

   return 0;
}
