// Fig. 15.12: fig15_12.cpp
// Driver to test the template Queue class
#include <iostream.h>
#include "queue.h"

int main()
{
   Queue< int > intQueue;
   int dequeueInteger;
   cout << "processing an integer Queue" << endl;

   for ( int i = 0; i < 4; i++ ) {
      intQueue.enqueue( i );
      intQueue.printQueue();
   }

   while ( !intQueue.isQueueEmpty() ) {
      intQueue.dequeue( dequeueInteger );
      cout << dequeueInteger << " dequeued" << endl;
      intQueue.printQueue();
   }

   Queue< double > doubleQueue;
   double val = 1.1, dequeuedouble;

   cout << "processing a double Queue" << endl;

   for ( i = 0; i < 4; i++ ) {
      doubleQueue.enqueue( val );
      doubleQueue.printQueue();
      val += 1.1;
   }

   while ( !doubleQueue.isQueueEmpty() ) {
      doubleQueue.dequeue( dequeuedouble );
      cout << dequeuedouble << " dequeued" << endl;
      doubleQueue.printQueue();
   }

   return 0;
}
