// Fig. 15.16: fig15_16.cpp
// Driver to test class Tree
#include <iostream.h>
#include <iomanip.h>
#include "tree.h"

int main()
{
   Tree< int > intTree;
   int intVal;

   cout << "Enter 10 integer values:\n";
   for( int i = 0; i < 10; i++ ) {
      cin >> intVal;
      intTree.insertNode( intVal );
   }

   cout << "\nPreorder traversal\n";
   intTree.preOrderTraversal();

   cout << "\nInorder traversal\n";
   intTree.inOrderTraversal();

   cout << "\nPostorder traversal\n";
   intTree.postOrderTraversal();

   Tree< double > doubleTree;
   double doubleVal;

   cout << "\n\n\nEnter 10 double values:\n"
        << setiosflags( ios::fixed | ios::showpoint )
        << setprecision( 1 );
   for ( i = 0; i < 10; i++ ) {
      cin >> doubleVal;
      doubleTree.insertNode( doubleVal );
   }

   cout << "\nPreorder traversal\n";
   doubleTree.preOrderTraversal();

   cout << "\nInorder traversal\n";
   doubleTree.inOrderTraversal();

   cout << "\nPostorder traversal\n";
   doubleTree.postOrderTraversal();

   return 0;
}
