// Fig. 19.10: fig19_10.cpp
// Using an iterator to output a string.
#include <iostream>
#include <string>
using namespace std;

int main()
{
   string s( "Testing iterators" );
   string::const_iterator i1 = s.begin();

   cout << "s = " << s
        << "\n(Using iterator i1) s is: ";

   while ( i1 != s.end() ) {
      cout << *i1;    // dereference iterator to get char
      ++i1;           // advance iterator to next char
   }

   cout << endl;
   return 0;
}