// Fig. 21.4: fig21_04.cpp
// Demonstrating reinterpret_cast operator.
#include <iostream.h>

int main()
{
   unsigned x = 22, *unsignedPtr;
   void *voidPtr = &x;
   char *charPtr = "C++";

   // cast from void * to unsigned *
   unsignedPtr = reinterpret_cast< unsigned * >( voidPtr );

   cout << "*unsignedPtr is " << *unsignedPtr 
        << "\ncharPtr is " << charPtr;

   // use reinterpret_cast to cast a char * pointer to unsigned
   cout << "\nchar * to unsigned results in: "
        << ( x = reinterpret_cast< unsigned >( charPtr ) );

   // cast unsigned back to char *
   cout << "\nunsigned to char * results in: "
        << reinterpret_cast< char * >( x ) << endl;

   return 0;
}