// Fig. 21.6: fig21_06.cpp
// Demonstrating RTTI capability typeid.
#include <iostream.h>
#include <typeinfo.h>

template < typename T >
T maximum( T value1, T value2, T value3 )
{
   T max = value1;

   if ( value2 > max )
      max = value2;

   if ( value3 > max )
      max = value3;

   // get the name of the type (i.e., int or double)
   const char *dataType = typeid( T ).name();

   cout << dataType << "s were compared.\nLargest "
        << dataType << " is ";

   return max;
}

int main()
{
   int a = 8, b = 88, c = 22;
   double d = 95.96, e = 78.59, f = 83.89;

   cout << maximum( a, b, c ) << "\n";
   cout << maximum( d, e, f ) << endl;

   return 0;
}
