// Fig. 21.12: fig21_12.cpp
// Demonstrating storage class specifier mutable.
#include <iostream.h>

class TestMutable {
public:
   TestMutable( int v = 0 ) { value = v; }
   void modifyValue() const { value++; }
   int getValue() const { return value; }
private:
   mutable int value;
};

int main()
{
   const TestMutable t( 99 );
   
   cout << "Initial value: " << t.getValue();

   t.modifyValue();   // modifies mutable member
   cout << "\nModified value: " << t.getValue() << endl;

   return 0;
}
