// Fig. 2.9: fig02_09.cpp
// Class average program with sentinel-controlled repetition.
#include <iostream.h>
#include <iomanip.h>

int main()
{
   int total,        // sum of grades
       gradeCounter, // number of grades entered
       grade;        // one grade       
   float average;    // number with decimal point for average

   // initialization phase
   total = 0;
   gradeCounter = 0;

   // processing phase
   cout << "Enter grade, -1 to end: ";    
   cin >> grade;                         

   while ( grade != -1 ) {                  
      total = total + grade;              
      gradeCounter = gradeCounter + 1;              
      cout << "Enter grade, -1 to end: "; 
      cin >> grade;                       
   }

   // termination phase
   if ( gradeCounter != 0 ) {     
      average = static_cast< float >( total ) / gradeCounter;   
      cout << "Class average is " << setprecision( 2 )
           << setiosflags( ios::fixed | ios::showpoint )
           << average << endl;
   }
   else
      cout << "No grades were entered" << endl;

   return 0;   // indicate program ended successfully
}

