// Fig. 15.9: stack.h
// Stack class template definition
// Derived from class List
#ifndef STACK_H
#define STACK_H

#include "list.h"

template< class STACKTYPE >
class Stack : private List< STACKTYPE > {
public:
   void push( const STACKTYPE &d ) { insertAtFront( d ); }
   bool pop( STACKTYPE &d ) { return removeFromFront( d ); }
   bool isStackEmpty() const { return isEmpty(); }
   void printStack() const { print(); }
};

#endif
