// Fig. 15.11: stack_c.h
// Definition of Stack class composed of List object
#ifndef STACK_C
#define STACK_C
#include "list.h"

template< class STACKTYPE >
class Stack {
public:
   // no constructor; List constructor does initialization
   void push( const STACKTYPE &d ) { s.insertAtFront( d ); }
   bool pop( STACKTYPE &d ) { return s.removeFromFront( d ); }
   bool isStackEmpty() const { return s.isEmpty(); }
   void printStack() const { s.print(); }
private:
   List< STACKTYPE > s;
};

#endif
