// Fig. 19.2: fig19_02.cpp
// Demonstrating string comparison capabilities
#include <iostream>
#include <string>
using namespace std;

int main()
{
   string s1( "Testing the comparison functions." ),
          s2("Hello" ), s3( "stinger" ), z1( s2 );
   
   cout << "s1: " << s1 << "\ns2: " << s2
	     << "\ns3: " << s3 << "\nz1: " << z1 << "\n\n";

   // comparing s1 and z1
   if ( s1 == z1 )
      cout << "s1 == z1\n";
   else { // s1 != z1 
      if ( s1 > z1 )
         cout << "s1 > z1\n";
      else // s1 < z1
         cout << "s1 < z1\n";
   }

   // comparing s1 and s2
   int f = s1.compare( s2 );

   if ( f == 0)
      cout << "s1.compare( s2 ) == 0\n";
   else if ( f > 0 )
      cout << "s1.compare( s2 ) > 0\n";
   else  // f < 0
      cout << "s1.compare( s2 ) < 0\n";

   // comparing s1 (elements 2 - 5) and s3 (elements 0 - 5)
   f = s1.compare( 2, 5, s3, 0, 5 );

   if ( f == 0 )
      cout << "s1.compare( 2, 5, s3, 0, 5 ) == 0\n";
   else if ( f > 0 )
      cout << "s1.compare( 2, 5, s3, 0, 5 ) > 0\n";                
   else  // f < 0
      cout << "s1.compare( 2, 5, s3, 0, 5 ) < 0\n";

   // comparing s2 and z1
   f = z1.compare( 0, s2.size(), s2 );

   if ( f == 0 )
      cout << "z1.compare( 0, s2.size(), s2 ) == 0" << endl;
   else if ( f > 0 )
      cout << "z1.compare( 0, s2.size(), s2 ) > 0" << endl;
   else  // f < 0
      cout << "z1.compare( 0, s2.size(), s2 ) < 0" << endl;

   return 0;
}
