// Fig. 21.13 fig21_13.cpp
// Demonstrating operators .* and ->*
#include <iostream.h>

class Test {
public:
   void function() { cout << "function\n"; }
   int value;
};

void arrowStar( Test * );
void dotStar( Test * );

int main()
{
   Test t;    
  
   t.value = 8;
   arrowStar( &t );
   dotStar( &t );
   return 0; 
}

void arrowStar( Test *tPtr )
{
   void ( Test::*memPtr )() = &Test::function;
   ( tPtr->*memPtr )();  // invoke function indirectly
}

void dotStar( Test *tPtr )
{
   int Test::*vPtr = &Test::value;
   cout << ( *tPtr ).*vPtr << endl;  // access value   
}
